#include "MyShiftOut.h"
#include <WProgram.h>

/********************************************************************************
 */
void MyKitt::setPins(MyOutPin* pinArray, int arrSize,  int timing)
{
  _pinArray = pinArray;
  _arrSize = arrSize;
  _timing = timing;

  _lastChange = 0;
  goingForward = true;
  currentPos = 0;
  pausing = false;

  _pinArray[0].turnOn();
  _pinArray[1].turnOn();
  for(int i = 2; i < _arrSize; i++)
  {
    _pinArray[i].turnOff();
  }
}

/********************************************************************************
 */
void MyKitt::inLoop()
{
  unsigned long now = millis();
  if(pausing)
  {
    for(int i = 0; i < _arrSize; i++)
    {
      _pinArray[i].turnOff();
    }
  }
  if(now - _lastChange > 200)
  {
    if(goingForward)
    {
      if(currentPos != 0)
      {
        _pinArray[currentPos - 1].turnOff();
      }
      currentPos++;
      if(currentPos == _arrSize)
      {
        goingForward = false;
      }
      else
      {
        _pinArray[currentPos].turnOn();
      }
    }
    else // going backwards
    {
      if(currentPos != _arrSize)
      {
        _pinArray[currentPos].turnOff();
      }
      currentPos--;
      if(currentPos == 0)
      {
        goingForward = true;
      }
      else
      {
        _pinArray[currentPos - 1].turnOn();
      }
    }
    _lastChange = now;
  }
}

/********************************************************************************
 */
void MyKitt::turnOn()
{
  pausing = false;
}

/********************************************************************************
 */
void MyKitt::turnOff()
{
  pausing = true;
}

